diff --git a/src/app/api/runtime/stream/route.ts b/src/app/api/runtime/stream/route.ts
new file mode 100644
index 0000000..ff5d837
--- /dev/null
+++ b/src/app/api/runtime/stream/route.ts
@@ -0,0 +1,80 @@
+import { bbDaemon } from '../../../../lib/bb-daemon';
+
+export const dynamic = 'force-dynamic';
+
+const encoder = new TextEncoder();
+const HEARTBEAT_MS = 15_000;
+const POLL_MS = 250;
+
+function toRuntimeSseFrame(event: unknown): string {
+  return `event: runtime\ndata: ${JSON.stringify(event)}\n\n`;
+}
+
+export async function GET(request: Request): Promise<Response> {
+  const { searchParams } = new URL(request.url);
+  const projectRoot = searchParams.get('projectRoot');
+
+  if (!projectRoot) {
+    return Response.json({ ok: false, error: 'projectRoot is required' }, { status: 400 });
+  }
+
+  await bbDaemon.start();
+
+  let cleanup = () => {};
+  const stream = new ReadableStream<Uint8Array>({
+    start(controller) {
+      let closed = false;
+      const write = (payload: string) => {
+        if (!closed) controller.enqueue(encoder.encode(payload));
+      };
+
+      write(': connected\n\n');
+
+      const seenIds = new Set<string>();
+      const seed = bbDaemon.listEvents(projectRoot);
+      for (const event of seed) {
+        seenIds.add(event.id);
+        write(toRuntimeSseFrame(event));
+      }
+
+      const poll = setInterval(() => {
+        const current = bbDaemon.listEvents(projectRoot);
+        const unseen = current.filter((event) => !seenIds.has(event.id));
+        for (const event of unseen.reverse()) {
+          seenIds.add(event.id);
+          write(toRuntimeSseFrame(event));
+        }
+      }, POLL_MS);
+
+      const heartbeat = setInterval(() => {
+        write(': heartbeat\n\n');
+      }, HEARTBEAT_MS);
+
+      const close = () => {
+        if (closed) return;
+        closed = true;
+        clearInterval(heartbeat);
+        clearInterval(poll);
+        request.signal.removeEventListener('abort', close);
+        try {
+          controller.close();
+        } catch {}
+      };
+
+      cleanup = close;
+      request.signal.addEventListener('abort', close);
+    },
+    cancel() {
+      cleanup();
+      return Promise.resolve();
+    },
+  });
+
+  return new Response(stream, {
+    headers: {
+      'Content-Type': 'text/event-stream; charset=utf-8',
+      'Cache-Control': 'no-cache, no-transform',
+      Connection: 'keep-alive',
+    },
+  });
+}
diff --git a/src/app/api/runtime/worker-status/route.ts b/src/app/api/runtime/worker-status/route.ts
new file mode 100644
index 0000000..1d4d871
--- /dev/null
+++ b/src/app/api/runtime/worker-status/route.ts
@@ -0,0 +1,37 @@
+// src/app/api/runtime/worker-status/route.ts
+import { NextResponse } from 'next/server';
+import { workerSessionManager } from '../../../../lib/worker-session-manager';
+
+export async function GET(request: Request) {
+  try {
+    const { searchParams } = new URL(request.url);
+    const beadId = searchParams.get('beadId');
+
+    if (!beadId) {
+      return NextResponse.json({ ok: false, error: 'beadId required' }, { status: 400 });
+    }
+
+    // Find worker for this bead
+    const workers = workerSessionManager.getAllWorkers();
+    const worker = workers.find(w => w.beadId === beadId);
+
+    if (!worker) {
+      return NextResponse.json({
+        ok: true,
+        workerStatus: 'idle',
+        agentTypeId: null,
+      });
+    }
+
+    return NextResponse.json({
+      ok: true,
+      workerStatus: worker.status,
+      workerDisplayName: worker.displayName,
+      workerError: worker.error,
+      agentTypeId: worker.agentTypeId,
+    });
+  } catch (error) {
+    const message = error instanceof Error ? error.message : String(error);
+    return NextResponse.json({ ok: false, error: message });
+  }
+}
diff --git a/src/app/layout.tsx b/src/app/layout.tsx
index 575e93f..443ce27 100644
--- a/src/app/layout.tsx
+++ b/src/app/layout.tsx
@@ -15,8 +15,8 @@ export const metadata: Metadata = {
 
 export default function RootLayout({ children }: { children: ReactNode }) {
   return (
-    <html lang="en" data-theme="aurora">
-      <body className={notoSans.variable}>{children}</body>
+    <html lang="en" data-theme="aurora" suppressHydrationWarning>
+      <body className={notoSans.variable} suppressHydrationWarning>{children}</body>
     </html>
   );
 }
diff --git a/src/app/page.tsx b/src/app/page.tsx
index 3bad47a..7f333e1 100644
--- a/src/app/page.tsx
+++ b/src/app/page.tsx
@@ -1,8 +1,14 @@
 import { Suspense } from 'react';
 import { UnifiedShell } from '../components/shared/unified-shell';
+import { OnboardingWizard } from '../components/onboarding/onboarding-wizard';
 import { readIssuesForScope } from '../lib/aggregate-read';
 import { resolveProjectScope } from '../lib/project-scope';
 import { listProjects } from '../lib/registry';
+import { bbDaemon } from '../lib/bb-daemon';
+import { detectPiRuntimeStrategy } from '../lib/pi-runtime-detection';
+import fs from 'node:fs/promises';
+import path from 'node:path';
+import os from 'node:os';
 
 export const dynamic = 'force-dynamic';
 
@@ -10,10 +16,45 @@ interface PageProps {
   searchParams?: Promise<Record<string, string | string[] | undefined>>;
 }
 
+async function checkOnboardingStatus(): Promise<{
+  hasProjects: boolean;
+  piInstalled: boolean;
+  hasAuth: boolean;
+}> {
+  // Check if any projects exist
+  const registryProjects = await listProjects();
+  const hasProjects = registryProjects.length > 0;
+
+  // Check if Pi is installed
+  const piResolution = await detectPiRuntimeStrategy();
+  const piInstalled = piResolution.installState === 'ready';
+
+  // Check if auth exists
+  const authPath = path.join(os.homedir(), '.beadboard', 'runtime', 'pi', 'agent', 'auth.json');
+  let hasAuth = false;
+  try {
+    const authContent = await fs.readFile(authPath, 'utf8');
+    const auth = JSON.parse(authContent);
+    hasAuth = Object.keys(auth.providers || {}).length > 0;
+  } catch {
+    hasAuth = false;
+  }
+
+  return { hasProjects, piInstalled, hasAuth };
+}
+
 export default async function Page({ searchParams }: PageProps) {
   const params = (await searchParams) ?? {};
   const requestedProjectKey = typeof params.project === 'string' ? params.project : null;
   const requestedMode = typeof params.mode === 'string' ? params.mode : null;
+  
+  // Check if we should skip onboarding (user has seen it or explicitly skipped)
+  const skipOnboarding = params.onboarded === 'true' || params.skip === 'true';
+  
+  // Check onboarding status
+  const onboardingStatus = await checkOnboardingStatus();
+  const needsOnboarding = !skipOnboarding && (!onboardingStatus.hasProjects || !onboardingStatus.piInstalled);
+
   const registryProjects = await listProjects();
   const scope = resolveProjectScope({
     currentProjectRoot: process.cwd(),
@@ -30,6 +71,22 @@ export default async function Page({ searchParams }: PageProps) {
     skipAgentFilter: true,
   });
   
+  // Start daemon in background
+  void bbDaemon.ensureRunning();
+
+  // Show onboarding wizard if needed
+  if (needsOnboarding) {
+    return (
+      <Suspense>
+        <OnboardingWizard
+          hasProjects={onboardingStatus.hasProjects}
+          piInstalled={onboardingStatus.piInstalled}
+          hasAuth={onboardingStatus.hasAuth}
+        />
+      </Suspense>
+    );
+  }
+  
   return (
     <Suspense>
       <UnifiedShell
diff --git a/src/cli/beadboard-cli.ts b/src/cli/beadboard-cli.ts
index 2320c91..0f76305 100644
--- a/src/cli/beadboard-cli.ts
+++ b/src/cli/beadboard-cli.ts
@@ -25,6 +25,10 @@ import {
   statusAgentReservations,
   type ReservationCommandResponse,
 } from '../lib/agent-reservations';
+import { bbDaemon } from '../lib/bb-daemon';
+import { bootstrapManagedPi } from '../lib/bb-pi-bootstrap';
+import { renderDaemonTuiText } from '../tui/bb-daemon-tui';
+import { runBbAgentTui } from '../tui/bb-agent-tui';
 
 export type CliResult = {
   ok: boolean;
@@ -276,6 +280,102 @@ async function runAgentCli(argv: string[], asJson: boolean): Promise<CliResult>
   }
 }
 
+function renderDaemonHelpText(): string {
+  return [
+    'Usage: bb daemon <command> [options]',
+    '',
+    'Commands:',
+    '  start        Start the BeadBoard daemon lifecycle',
+    '  status       Show daemon lifecycle and project status',
+    '  stop         Stop the BeadBoard daemon lifecycle',
+    '  bootstrap    Install the BeadBoard agent runtime',
+    '  tui          Open the interactive BeadBoard agent TUI',
+    '',
+    'TUI options:',
+    '  --project-root <path>   Run the bb agent in an explicit external project workspace',
+    '  --project-key <key>     Run the bb agent in a registered BeadBoard project workspace',
+  ].join('\n');
+}
+
+async function runDaemonCli(argv: string[], asJson: boolean): Promise<CliResult> {
+  const subcommand = argv[0];
+  const projectRootFlagIndex = argv.indexOf('--project-root');
+  const projectKeyFlagIndex = argv.indexOf('--project-key');
+  const projectRoot = projectRootFlagIndex >= 0 ? argv[projectRootFlagIndex + 1] : undefined;
+  const projectKey = projectKeyFlagIndex >= 0 ? argv[projectKeyFlagIndex + 1] : undefined;
+  if (!subcommand || subcommand === '--help' || subcommand === '-h' || subcommand === 'help') {
+    return { ok: true, command: 'daemon help', text: renderDaemonHelpText() };
+  }
+
+  if (subcommand === 'start') {
+    const lifecycle = await bbDaemon.start();
+    const status = bbDaemon.getStatus();
+    const runtimeMode = status.piRuntime ? `${status.piRuntime.mode} / ${status.piRuntime.installState}` : 'unknown';
+    return {
+      ok: true,
+      command: 'daemon start',
+      text: `✓ BeadBoard daemon started (${lifecycle.status}) using ${runtimeMode}`,
+      lifecycle,
+      status,
+    };
+  }
+
+  if (subcommand === 'status') {
+    const status = bbDaemon.getStatus();
+    const runtimeMode = status.piRuntime ? `${status.piRuntime.mode} / ${status.piRuntime.installState}` : 'unknown';
+    return {
+      ok: true,
+      command: 'daemon status',
+      text: `Daemon: ${status.lifecycle.status} (${status.daemon.projectCount} projects) · Agent runtime: ${runtimeMode}`,
+      status,
+    };
+  }
+
+  if (subcommand === 'stop') {
+    const lifecycle = await bbDaemon.stop();
+    return {
+      ok: true,
+      command: 'daemon stop',
+      text: `✓ BeadBoard daemon stopped (${lifecycle.status})`,
+      lifecycle,
+      status: bbDaemon.getStatus(),
+    };
+  }
+
+  if (subcommand === 'bootstrap' || subcommand === 'bootstrap-pi') {
+    const result = await bootstrapManagedPi();
+    return {
+      ok: true,
+      command: 'daemon bootstrap',
+      text: result.alreadyInstalled
+        ? `✓ BeadBoard agent runtime ready at ${result.managedRoot}`
+        : `✓ BeadBoard agent runtime installed at ${result.managedRoot}`,
+      bootstrap: result,
+    };
+  }
+
+  if (subcommand === 'tui') {
+    await bbDaemon.ensureRunning();
+    return {
+      ok: true,
+      command: 'daemon tui',
+      text: 'Starting interactive BeadBoard agent TUI...',
+      preview: renderDaemonTuiText(),
+      status: bbDaemon.getStatus(),
+      planned: false,
+      interactive: true,
+      projectRoot: projectRoot ?? null,
+      projectKey: projectKey ?? null,
+    };
+  }
+
+  const error = { code: 'CLI_ERROR', message: `Unknown daemon command: ${subcommand}` };
+  if (asJson) {
+    return { ok: false, command: `daemon ${subcommand}`, error };
+  }
+  return { ok: false, command: `daemon ${subcommand}`, text: `Error: ${error.message}`, error };
+}
+
 function parseVersion(env: NodeJS.ProcessEnv): string {
   const raw = (env.BB_RUNTIME_VERSION || env.npm_package_version || '0.1.0').trim();
   return raw.startsWith('v') ? raw.slice(1) : raw;
@@ -297,6 +397,11 @@ export async function runCli(argv: string[], env: NodeJS.ProcessEnv = process.en
     return runAgentCli(subArgs, asJson);
   }
 
+  if (command === 'daemon') {
+    const subArgs = commandIndex >= 0 ? args.slice(commandIndex + 1) : [];
+    return runDaemonCli(subArgs, asJson);
+  }
+
   if (command === 'doctor') {
     return {
       ok: true,
@@ -343,7 +448,8 @@ export async function runCli(argv: string[], env: NodeJS.ProcessEnv = process.en
   return {
     ok: true,
     command: 'help',
-    usage: 'beadboard <doctor|self-update|uninstall> [--json] [--yes]',
+    usage: 'beadboard <agent|daemon|doctor|self-update|uninstall> [--json] [--yes]',
+    text: renderHelpText(),
   };
 }
 
@@ -356,6 +462,7 @@ function renderHelpText(): string {
     '  beadboard start [--dolt]     Start BeadBoard runtime (optionally start Dolt first)',
     '  beadboard open               Open BeadBoard in browser',
     '  beadboard status [--json]    Show runtime + bd diagnostics',
+    '  beadboard daemon <command>   Control the BeadBoard daemon lifecycle',
     '  beadboard agent <command>    Run coordination commands (register/send/inbox/ack/reserve/...)',
     '',
     'Management Commands:',
@@ -371,6 +478,24 @@ function renderHelpText(): string {
 async function main() {
   const argv = process.argv.slice(2);
   const asJson = argv.includes('--json');
+  const isDaemonTui = argv[0] === 'daemon' && argv[1] === 'tui' && !asJson;
+
+  if (isDaemonTui) {
+    const projectRootFlagIndex = argv.indexOf('--project-root');
+    const projectKeyFlagIndex = argv.indexOf('--project-key');
+    const projectRoot = projectRootFlagIndex >= 0 ? argv[projectRootFlagIndex + 1] : undefined;
+    const projectKey = projectKeyFlagIndex >= 0 ? argv[projectKeyFlagIndex + 1] : undefined;
+
+    await bbDaemon.ensureRunning();
+    await runBbAgentTui({
+      cwd: process.cwd(),
+      projectRoot,
+      projectKey,
+      testMode: process.env.BB_TUI_TEST_MODE === '1',
+    });
+    return;
+  }
+
   const result = await runCli(argv);
   if (!asJson && result.command === 'help') {
     process.stdout.write(`${renderHelpText()}\n`);
diff --git a/src/components/activity/activity-panel.tsx b/src/components/activity/activity-panel.tsx
index ccf077e..c772967 100644
--- a/src/components/activity/activity-panel.tsx
+++ b/src/components/activity/activity-panel.tsx
@@ -24,24 +24,24 @@ export type EventTone = {
   idClass: string;
 };
 
-interface AgentRosterEntry {
-  name: string;
-  status: AgentStatus;
-  lastSeen: string | null;
-  beadId: string;
-}
-
-interface CoordMessage {
-  message_id: string;
-  bead_id: string;
-  from_agent: string;
-  to_agent: string;
-  category: 'HANDOFF' | 'BLOCKED' | 'DECISION' | 'INFO';
-  subject: string;
-  state: 'unread' | 'read' | 'acked';
-  created_at: string;
-  acked_at: string | null;
-}
+interface AgentRosterEntry {
+  name: string;
+  status: AgentStatus;
+  lastSeen: string | null;
+  beadId: string;
+}
+
+interface CoordMessage {
+  message_id: string;
+  bead_id: string;
+  from_agent: string;
+  to_agent: string;
+  category: 'HANDOFF' | 'BLOCKED' | 'DECISION' | 'INFO';
+  subject: string;
+  state: 'unread' | 'read' | 'acked';
+  created_at: string;
+  acked_at: string | null;
+}
 
 interface ActivityPanelProps {
   issues: BeadIssue[];
@@ -51,6 +51,21 @@ interface ActivityPanelProps {
 
 const AGENT_LABEL = 'gt:agent';
 
+function mergeUniqueActivities(existing: ActivityEvent[], incoming: ActivityEvent[]): ActivityEvent[] {
+  const seen = new Set<string>();
+  const merged: ActivityEvent[] = [];
+
+  for (const event of [...incoming, ...existing]) {
+    if (seen.has(event.id)) continue;
+    seen.add(event.id);
+    merged.push(event);
+  }
+
+  return merged
+    .sort((a, b) => new Date(b.timestamp).getTime() - new Date(a.timestamp).getTime())
+    .slice(0, 50);
+}
+
 // Determine agent status based on last activity
 function deriveAgentStatus(lastSeenAt: string | null): AgentStatus {
   if (!lastSeenAt) return 'dead';
@@ -152,23 +167,23 @@ function getAgentTone(status: AgentStatus): AgentTone {
 }
 
 // reopened=blue, closed=amber, created/opened=green, others semantic
-export function getEventTone(kind: string): EventTone {
-  const normalized = kind.toLowerCase();
-  const byKind: Record<string, EventTone> = {
-    coord_send: {
-      label: 'Coord Send',
-      labelClass: 'text-[#D4A574]',
-      dotClass: 'bg-[#D4A574]',
-      cardClass: 'bg-[var(--status-in-progress)]',
-      idClass: 'text-[#DAB891]',
-    },
-    coord_ack: {
-      label: 'Coord Ack',
-      labelClass: 'text-[#7CB97A]',
-      dotClass: 'bg-[#7CB97A]',
-      cardClass: 'bg-[var(--status-ready)]',
-      idClass: 'text-[#9ACB98]',
-    },
+export function getEventTone(kind: string): EventTone {
+  const normalized = kind.toLowerCase();
+  const byKind: Record<string, EventTone> = {
+    coord_send: {
+      label: 'Coord Send',
+      labelClass: 'text-[#D4A574]',
+      dotClass: 'bg-[#D4A574]',
+      cardClass: 'bg-[var(--status-in-progress)]',
+      idClass: 'text-[#DAB891]',
+    },
+    coord_ack: {
+      label: 'Coord Ack',
+      labelClass: 'text-[#7CB97A]',
+      dotClass: 'bg-[#7CB97A]',
+      cardClass: 'bg-[var(--status-ready)]',
+      idClass: 'text-[#9ACB98]',
+    },
     created: {
       label: 'Created',
       labelClass: 'text-[#7CB97A]',
@@ -270,95 +285,95 @@ export function getInitials(name: string): string {
   return name.split(/[-_\s]/).map(p => p[0]).join('').toUpperCase().slice(0, 2);
 }
 
-export function ActivityPanel({ issues, collapsed = false, projectRoot }: ActivityPanelProps) {
-  const [activities, setActivities] = useState<ActivityEvent[]>([]);
-  const [coordActivities, setCoordActivities] = useState<ActivityEvent[]>([]);
-  const [reservationByAgent, setReservationByAgent] = useState<Record<string, string | undefined>>({});
-  const [isLoading, setIsLoading] = useState(true);
+export function ActivityPanel({ issues, collapsed = false, projectRoot }: ActivityPanelProps) {
+  const [activities, setActivities] = useState<ActivityEvent[]>([]);
+  const [coordActivities, setCoordActivities] = useState<ActivityEvent[]>([]);
+  const [reservationByAgent, setReservationByAgent] = useState<Record<string, string | undefined>>({});
+  const [isLoading, setIsLoading] = useState(true);
 
   const agentRoster = useMemo(() => buildAgentRoster(issues), [issues]);
 
-  // Fetch activity history
-  useEffect(() => {
-    async function fetchActivity() {
+  // Fetch activity history
+  useEffect(() => {
+    async function fetchActivity() {
       try {
         const response = await fetch('/api/activity');
         if (response.ok) {
           const data = await response.json();
-          setActivities(data.slice(0, 50)); // Limit to 50 events
-        }
-      } catch (error) {
-        console.error('[ActivityPanel] Failed to fetch activity:', error);
-      } finally {
-        setIsLoading(false);
-      }
-    }
-
-    fetchActivity();
-  }, []);
-
-  useEffect(() => {
-    const fetchCoordination = async () => {
-      if (agentRoster.length === 0) {
-        setCoordActivities([]);
-        setReservationByAgent({});
-        return;
-      }
-
-      // Use batch endpoints to reduce API calls from 2N to 2
-      const agentNames = agentRoster.map(a => a.name).join(',');
-
-      const [mailResponse, reservationsResponse] = await Promise.all([
-        fetch(`/api/agents/mail/batch?agents=${encodeURIComponent(agentNames)}&limit=15`),
-        fetch(`/api/agents/reservations/batch?agents=${encodeURIComponent(agentNames)}`),
-      ]);
-
-      const mailPayload = await mailResponse.json().catch(() => ({ ok: false, data: [] }));
-      const reservationsPayload = await reservationsResponse.json().catch(() => ({ ok: false, data: [] }));
-
-      // Collect all messages from all agents
-      const uniqueMessages = new Map<string, CoordMessage>();
-      if (mailPayload.ok && mailPayload.data) {
-        for (const entry of mailPayload.data) {
-          for (const message of (entry.messages ?? [])) {
-            uniqueMessages.set(message.message_id, message);
-          }
-        }
-      }
-
-      const mapped = [...uniqueMessages.values()]
-        .map((message) => ({
-          id: `coord-${message.message_id}`,
-          kind: (message.state === 'acked' ? 'coord_ack' : 'coord_send') as ActivityEvent['kind'],
-          beadId: message.bead_id,
-          beadTitle: `${message.category}: ${message.subject}`,
-          timestamp: message.state === 'acked' && message.acked_at ? message.acked_at : message.created_at,
-          actor: message.state === 'acked' ? message.to_agent : message.from_agent,
-          projectId: projectRoot,
-          projectName: 'beadboard',
-          payload: {},
-        }))
-        .sort((a, b) => new Date(b.timestamp).getTime() - new Date(a.timestamp).getTime())
-        .slice(0, 25);
-
-      // Build reservation map
-      const reservationMap: Record<string, string | undefined> = {};
-      if (reservationsPayload.ok && reservationsPayload.data) {
-        for (const entry of reservationsPayload.data) {
-          reservationMap[entry.agent] = entry.scope;
-        }
-      }
-
-      setCoordActivities(mapped);
-      setReservationByAgent(reservationMap);
-    };
-
-    void fetchCoordination();
-    const timer = setInterval(() => {
-      void fetchCoordination();
-    }, 15000);
-    return () => clearInterval(timer);
-  }, [agentRoster, projectRoot]);
+          setActivities((prev) => mergeUniqueActivities(prev, data));
+        }
+      } catch (error) {
+        console.error('[ActivityPanel] Failed to fetch activity:', error);
+      } finally {
+        setIsLoading(false);
+      }
+    }
+
+    fetchActivity();
+  }, []);
+
+  useEffect(() => {
+    const fetchCoordination = async () => {
+      if (agentRoster.length === 0) {
+        setCoordActivities([]);
+        setReservationByAgent({});
+        return;
+      }
+
+      // Use batch endpoints to reduce API calls from 2N to 2
+      const agentNames = agentRoster.map(a => a.name).join(',');
+
+      const [mailResponse, reservationsResponse] = await Promise.all([
+        fetch(`/api/agents/mail/batch?agents=${encodeURIComponent(agentNames)}&limit=15`),
+        fetch(`/api/agents/reservations/batch?agents=${encodeURIComponent(agentNames)}`),
+      ]);
+
+      const mailPayload = await mailResponse.json().catch(() => ({ ok: false, data: [] }));
+      const reservationsPayload = await reservationsResponse.json().catch(() => ({ ok: false, data: [] }));
+
+      // Collect all messages from all agents
+      const uniqueMessages = new Map<string, CoordMessage>();
+      if (mailPayload.ok && mailPayload.data) {
+        for (const entry of mailPayload.data) {
+          for (const message of (entry.messages ?? [])) {
+            uniqueMessages.set(message.message_id, message);
+          }
+        }
+      }
+
+      const mapped = [...uniqueMessages.values()]
+        .map((message) => ({
+          id: `coord-${message.message_id}`,
+          kind: (message.state === 'acked' ? 'coord_ack' : 'coord_send') as ActivityEvent['kind'],
+          beadId: message.bead_id,
+          beadTitle: `${message.category}: ${message.subject}`,
+          timestamp: message.state === 'acked' && message.acked_at ? message.acked_at : message.created_at,
+          actor: message.state === 'acked' ? message.to_agent : message.from_agent,
+          projectId: projectRoot,
+          projectName: 'beadboard',
+          payload: {},
+        }))
+        .sort((a, b) => new Date(b.timestamp).getTime() - new Date(a.timestamp).getTime())
+        .slice(0, 25);
+
+      // Build reservation map
+      const reservationMap: Record<string, string | undefined> = {};
+      if (reservationsPayload.ok && reservationsPayload.data) {
+        for (const entry of reservationsPayload.data) {
+          reservationMap[entry.agent] = entry.scope;
+        }
+      }
+
+      setCoordActivities(mapped);
+      setReservationByAgent(reservationMap);
+    };
+
+    void fetchCoordination();
+    const timer = setInterval(() => {
+      void fetchCoordination();
+    }, 15000);
+    return () => clearInterval(timer);
+  }, [agentRoster, projectRoot]);
 
   // Subscribe to real-time activity
   useEffect(() => {
@@ -371,7 +386,7 @@ export function ActivityPanel({ issues, collapsed = false, projectRoot }: Activi
         console.log('[ActivityPanel] Received activity event:', data);
         // data IS the activity event directly (not wrapped in { event: ... })
         if (data?.beadId) {
-          setActivities(prev => [data, ...prev].slice(0, 50));
+          setActivities(prev => mergeUniqueActivities(prev, [data]));
         }
       } catch (e) {
         // Ignore parse errors
@@ -387,13 +402,11 @@ export function ActivityPanel({ issues, collapsed = false, projectRoot }: Activi
     };
   }, [projectRoot]);
 
-  const activeAgents = agentRoster.filter(a => a.status === 'active').length;
-  const mergedActivities = useMemo(
-    () => [...coordActivities, ...activities]
-      .sort((a, b) => new Date(b.timestamp).getTime() - new Date(a.timestamp).getTime())
-      .slice(0, 50),
-    [activities, coordActivities],
-  );
+  const activeAgents = agentRoster.filter(a => a.status === 'active').length;
+  const mergedActivities = useMemo(
+    () => mergeUniqueActivities(coordActivities, activities),
+    [activities, coordActivities],
+  );
   if (collapsed) {
     return (
       <div className="flex flex-col items-center gap-6 py-6 h-full bg-[var(--surface-secondary)]">
@@ -425,7 +438,7 @@ export function ActivityPanel({ issues, collapsed = false, projectRoot }: Activi
 
         {/* Activity Pulses */}
         <div className="flex flex-col gap-2 opacity-40">
-          {mergedActivities.slice(0, 8).map((act) => (
+          {mergedActivities.slice(0, 8).map((act) => (
             <div key={act.id} className={cn(
               "w-1 h-1 rounded-full",
               getEventTone(act.kind).dotClass
@@ -473,20 +486,20 @@ export function ActivityPanel({ issues, collapsed = false, projectRoot }: Activi
                 <div className="flex flex-col flex-1 min-w-0">
                   <span className="text-xs font-semibold text-text-primary group-hover:text-white transition-colors">{agent.name}</span>
                   <div className="flex items-center gap-1.5">
-                    <span className={cn(
-                      "text-[9px] uppercase tracking-wider font-bold",
-                      getAgentTone(agent.status).labelClass
-                    )}>
-                      {agent.status}
-                    </span>
-                    {reservationByAgent[agent.name] ? (
-                      <span className="max-w-[140px] truncate rounded border border-cyan-500/30 bg-cyan-500/10 px-1 py-0.5 text-[9px] text-cyan-200" title={reservationByAgent[agent.name]}>
-                        {reservationByAgent[agent.name]}
-                      </span>
-                    ) : null}
-                    <span className="text-[9px] text-text-muted/40 font-mono">
-                      {agent.lastSeen ? formatRelativeTime(agent.lastSeen) : 'N/A'}
-                    </span>
+                    <span className={cn(
+                      "text-[9px] uppercase tracking-wider font-bold",
+                      getAgentTone(agent.status).labelClass
+                    )}>
+                      {agent.status}
+                    </span>
+                    {reservationByAgent[agent.name] ? (
+                      <span className="max-w-[140px] truncate rounded border border-cyan-500/30 bg-cyan-500/10 px-1 py-0.5 text-[9px] text-cyan-200" title={reservationByAgent[agent.name]}>
+                        {reservationByAgent[agent.name]}
+                      </span>
+                    ) : null}
+                    <span className="text-[9px] text-text-muted/40 font-mono">
+                      {agent.lastSeen ? formatRelativeTime(agent.lastSeen) : 'N/A'}
+                    </span>
                   </div>
                 </div>
               </div>
@@ -508,13 +521,13 @@ export function ActivityPanel({ issues, collapsed = false, projectRoot }: Activi
               <div className="w-4 h-4 border-2 border-teal-500 border-t-transparent rounded-full animate-spin" />
               <span className="text-[10px] font-mono text-text-muted">SYNCING...</span>
             </div>
-          ) : mergedActivities.length === 0 ? (
+          ) : mergedActivities.length === 0 ? (
             <div className="p-10 text-center opacity-30">
               <p className="text-[10px] font-mono">VOID_STREAM_NULL</p>
             </div>
           ) : (
             <div className="p-3 space-y-3">
-              {mergedActivities.map((activity) => {
+              {mergedActivities.map((activity) => {
                 const eventTone = getEventTone(activity.kind);
                 return (
                   <div key={activity.id} className="group relative">
diff --git a/src/components/activity/contextual-right-panel.tsx b/src/components/activity/contextual-right-panel.tsx
index 2108555..9b8a216 100644
--- a/src/components/activity/contextual-right-panel.tsx
+++ b/src/components/activity/contextual-right-panel.tsx
@@ -7,6 +7,7 @@ import { ActivityPanel } from './activity-panel';
 import { SwarmCommandFeed } from './swarm-command-feed';
 import { ThreadDrawer } from '../shared/thread-drawer';
 import { MissionInspector } from '../mission/mission-inspector';
+import { AgentStatusPanel } from '../agents/agent-status-panel';
 import { useSwarmList } from '../../hooks/use-swarm-list';
 import { useUrlState } from '../../hooks/use-url-state';
 
@@ -58,6 +59,10 @@ export function ContextualRightPanel({ epicId, taskId, swarmId, issues, projectR
                         </button>
                     </div>
                 )}
+                {/* Agent Status for active epic */}
+                <div className="shrink-0 border-b border-[var(--border-subtle)] p-3">
+                    <AgentStatusPanel projectRoot={projectRoot} />
+                </div>
                 <div className="min-h-0 flex-1 overflow-hidden">
                     <SwarmCommandFeed
                         epicId={epicId}
@@ -116,13 +121,21 @@ function SwarmIdBranch({ swarmId, projectRoot }: { swarmId: string; projectRoot:
     const assignedAgents = swarm?.agents ?? [];
 
     return (
-        <MissionInspector
-            missionId={swarmId}
-            missionTitle={missionTitle}
-            projectRoot={projectRoot}
-            assignedAgents={assignedAgents}
-            onClose={() => setSwarmId(null)}
-            onAssign={async () => {}}
-        />
+        <div className="flex h-full flex-col overflow-hidden">
+            {/* Agent Status for active swarm */}
+            <div className="shrink-0 border-b border-[var(--border-subtle)] p-3">
+                <AgentStatusPanel projectRoot={projectRoot} />
+            </div>
+            <div className="min-h-0 flex-1 overflow-hidden">
+                <MissionInspector
+                    missionId={swarmId}
+                    missionTitle={missionTitle}
+                    projectRoot={projectRoot}
+                    assignedAgents={assignedAgents}
+                    onClose={() => setSwarmId(null)}
+                    onAssign={async () => {}}
+                />
+            </div>
+        </div>
     );
 }
